﻿using System;
using System.Speech.Recognition;
using System.Speech.Synthesis;

namespace SpeechSample
{
    class Program
    {
        static void Main( string[] args )
        {
            //1 Sintesis ------------------------------------------------------------------------------------------------------------
            //SpeechSynthesizer synth = new SpeechSynthesizer( );

            ////synth.SelectVoice( "Microsoft Sam" );
            ////synth.Speak( "I'm Sam." );
            ////synth.Speak( "You may have heard me speaking to you in Windows XP." );
            ////synth.Speak( "Anna will make me redundant." );

            //synth.SelectVoice( "Microsoft Anna" );
            //synth.Speak( "I am the new voice in Windows." );
            //synth.Speak( "Sam belongs to a previous generation." );
            //synth.Speak( "I sound great." ); 

            //2 Prompt con SSML ------------------------------------------------------------------------------------------------------------
            SpeechSynthesizer synth = new SpeechSynthesizer( );
            PromptBuilder savedPrompt = new PromptBuilder( );
            savedPrompt.AppendSsml( @"..\..\prompt.ssml" );
            synth.Speak( savedPrompt ); 

            //3 Prompt ------------------------------------------------------------------------------------------------------------
            //PromptBuilder myPrompt = new PromptBuilder( );

            //PromptStyle mainStyle = new PromptStyle( );
            //mainStyle.Rate = PromptRate.Medium;
            //mainStyle.Volume = PromptVolume.Loud;
            //myPrompt.StartStyle( mainStyle );

            //myPrompt.AppendAudio( new Uri( "file://c:\\windows\\media\\notify.wav" ), "Attention!" );
            //myPrompt.AppendText( "Here are some important messages." );

            //myPrompt.AppendTextWithPronunciation( "WinFX", "wɪnɛfɛks" );
            //myPrompt.AppendText( "is a great platform." );

            //myPrompt.AppendText( "ASP.NET" );
            //myPrompt.AppendTextWithHint( "3.5", SayAs.NumberCardinal );
            //myPrompt.AppendText( "is an acronym for Active Server Pages. Whereas an ASP is a snake." );

            //myPrompt.AppendBreak( );

            //PromptStyle interimStyle = new PromptStyle( );
            //interimStyle.Emphasis = PromptEmphasis.Strong;
            //myPrompt.StartStyle( interimStyle );
            //myPrompt.AppendText( "Please remember these two things." );
            //myPrompt.EndStyle( );

            //myPrompt.AppendBreak( );
            //myPrompt.AppendText( "Thank you" );

            //myPrompt.EndStyle( );

            //SpeechSynthesizer synth = new SpeechSynthesizer( );
            //synth.Speak( myPrompt );

            //4 Speech Recognition ------------------------------------------------------------------------------------------------------------
            //GrammarBuilder grammarBuilder = new GrammarBuilder( new Choices( "Hello", "Speech Recognition" ) );

            //SpeechRecognitionEngine recognitionEngine = new SpeechRecognitionEngine( );
            //recognitionEngine.LoadGrammar( new Grammar( grammarBuilder ) );
            //recognitionEngine.SetInputToDefaultAudioDevice( );
            //recognitionEngine.RecognizeAsync( RecognizeMode.Multiple );

            //recognitionEngine.SpeechRecognized += new EventHandler<SpeechRecognizedEventArgs>( speechRecognized );

            //Console.WriteLine( "Escuchando..." );
            //Console.ReadLine( );
        }

        private static void speechRecognized( object sender, SpeechRecognizedEventArgs e )
        {
            if ( e.Result.Words[ 0 ].Confidence > 0.5 )
                Console.WriteLine( e.Result.Text );
            else
                Console.WriteLine( e.Result.Words[ 0 ].Confidence );
        }
    }
}